package name.panitz.parser;
import name.panitz.data.tree.*;

import java.util.List;

public class AddOpTree implements Parser<OpTree>{
  public ParseResult<OpTree> parse(List<Token> ts){
    return new Map<OpToken,OpTree>
      (new Alt<OpToken>
         (new ParseToken<OpToken>(OpToken.add)
         ,new ParseToken<OpToken>(OpToken.sub))
      ,new GetOpTree()).parse(ts);
  }
}