package name.panitz.parser;
import name.panitz.data.tree.*;

import java.util.List;

public class MultExprTree implements Parser<Tree<String>>{
  public ParseResult<Tree<String>> parse(List<Token> ts){
    return
      new Alt<Tree<String>>
       (new Map<Pair<Tree<String>,Pair<OpTree,Tree<String>>>,Tree<String>>
         (new Seq<Tree<String>,Pair<OpTree,Tree<String>>>
           (new ZahlTree(),new Seq<OpTree,Tree<String>>
                            (new MultOpTree(),new MultExprTree()))
         ,new DoOpTree()
         )
       ,new ZahlTree()
       ).parse(ts);
  }
}